diff -up ./src/netstatus-iface.h.clean ./src/netstatus-iface.h
--- ./src/netstatus-iface.h.clean	2009-10-20 08:28:14.754379483 +0100
+++ ./src/netstatus-iface.h	2009-10-20 08:21:43.523770530 +0100
@@ -1,5 +1,5 @@
 /*
- * Copyright (C) 2003 Sun Microsystems, Inc.
+ * Copyright (C) 2003-2009 Sun Microsystems, Inc.
  * Copyright (C) 2004 Red Hat Inc.
  *
  * This program is free software; you can redistribute it and/or
@@ -39,6 +39,8 @@ G_BEGIN_DECLS
 #define NETSTATUS_IS_IFACE_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), NETSTATUS_TYPE_IFACE))
 #define NETSTATUS_IFACE_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), NETSTATUS_TYPE_IFACE, NetstatusIfaceClass))
 
+#define NETSTATUS_IFACE_SIGNAL_RESTART_STATE "restart_state"
+
 typedef struct _NetstatusIface        NetstatusIface;
 typedef struct _NetstatusIfaceClass   NetstatusIfaceClass;
 typedef struct _NetstatusIfacePrivate NetstatusIfacePrivate;
@@ -53,6 +55,8 @@ struct _NetstatusIface
 struct _NetstatusIfaceClass
 {
   GObjectClass parent_class;
+
+  void (*restart_complete) (GObject *iface);
 };
 
 GList *                netstatus_list_interface_names        (GError         **error);
@@ -69,6 +73,13 @@ void                   netstatus_iface_g
 							      NetstatusStats  *stats);
 gboolean               netstatus_iface_get_is_wireless       (NetstatusIface  *iface);
 int                    netstatus_iface_get_signal_strength   (NetstatusIface  *iface);
+gboolean               netstatus_iface_get_is_connected      (NetstatusIface  *iface);
+G_CONST_RETURN char *  netstatus_iface_get_essid             (NetstatusIface  *iface);
+G_CONST_RETURN char *  netstatus_iface_get_bssid             (NetstatusIface  *iface);
+G_CONST_RETURN char *   netstatus_iface_get_bss_mode         (NetstatusIface *iface);
+G_CONST_RETURN char *  netstatus_iface_get_mode              (NetstatusIface  *iface);
+G_CONST_RETURN char *  netstatus_iface_get_security          (NetstatusIface  *iface);
+G_CONST_RETURN char *  netstatus_iface_get_auth_mode         (NetstatusIface  *iface);
 
 void                   netstatus_iface_set_error             (NetstatusIface  *iface,
 							      const GError    *error);
@@ -86,6 +97,17 @@ gboolean               netstatus_iface_g
 							      char           **hw_addr);
 gboolean               netstatus_iface_get_is_loopback       (NetstatusIface  *iface);
 
+gboolean               netstatus_iface_restart_available (NetstatusIface  *iface);
+gboolean               netstatus_iface_restart_inprogress (NetstatusIface  *iface);
+GPid                   netstatus_iface_restart (NetstatusIface  *iface);
+gint                   netstatus_iface_restart_get_status (NetstatusIface  *iface);
+G_CONST_RETURN gchar * netstatus_iface_restart_get_output (NetstatusIface  *iface);
+void                   netstatus_iface_restart_interrupt (NetstatusIface  *iface);
+
+gboolean               netstatus_iface_get_track_active_interface (NetstatusIface  *iface);
+void                   netstatus_iface_set_track_active_interface (NetstatusIface  *iface, gboolean track_active );
+void                   netstatus_iface_find_active_interface (NetstatusIface  *iface );
+
 G_END_DECLS
 
 #endif /* __NETSTATUS_IFACE_H__ */

--- gnome-netstatus-2.28.0.orig/src/netstatus.schemas.in	2009-09-25 11:46:34.295222345 +0100
+++ gnome-netstatus-2.28.0/src/netstatus.schemas.in	2009-09-25 11:46:40.209120418 +0100
@@ -12,6 +12,17 @@
       </locale>
     </schema>
 
+    <schema>
+      <key>/schemas/apps/netstatus_applet/prefs/track_active_interface</key>
+      <owner>netstatus-applet</owner>
+      <type>bool</type>
+      <default>false</default>
+      <locale name="C">
+        <short>Track active Network Interface</short>
+        <long>Have Network Monitor keep track of the active Network Interface</long>
+      </locale>
+    </schema>
+
     <!-- Yes, this key is purposely global to all instances of the applet -->
     <schema>
       <key>/schemas/apps/netstatus_applet/config_tool</key>
--- gnome-netstatus-2.28.0.orig/src/netstatus-applet.c	2009-09-25 11:46:34.295930633 +0100
+++ gnome-netstatus-2.28.0/src/netstatus-applet.c	2009-09-25 12:07:05.866671745 +0100
@@ -45,6 +45,7 @@
   
   GConfClient    *client;
   guint           notify_id;
+  guint           track_active_interface_id;
 };
 
 static void     netstatus_applet_instance_init             (NetstatusApplet           *applet,
@@ -69,6 +70,7 @@
 							    NetstatusApplet           *applet);
 static void     netstatus_applet_display_status_dialog     (NetstatusApplet           *applet);
 static void     netstatus_applet_iface_name_changed        (NetstatusApplet           *applet);
+static void     netstatus_applet_iface_track_active_changed(NetstatusApplet *applet);
 
 static GObjectClass *parent_class;
 
@@ -127,6 +129,10 @@
 			    G_CALLBACK (netstatus_applet_iface_name_changed),
 			    applet);
 
+  g_signal_connect_swapped (applet->priv->iface, "notify::track-active-interface",
+			    G_CALLBACK (netstatus_applet_iface_track_active_changed),
+			    applet);
+
   g_signal_connect_swapped (applet->priv->icon, "invoked",
 			    G_CALLBACK (netstatus_applet_display_status_dialog),
 			    applet);
@@ -168,6 +174,10 @@
     gconf_client_notify_remove (applet->priv->client, applet->priv->notify_id);
   applet->priv->notify_id = 0;
 
+  if (applet->priv->track_active_interface_id)
+    gconf_client_notify_remove (applet->priv->client, applet->priv->track_active_interface_id);
+  applet->priv->track_active_interface_id = 0;
+
   if (applet->priv->client)
     g_object_unref (applet->priv->client);
   applet->priv->client = NULL;
@@ -375,6 +385,19 @@
 }
 
 static void
+netstatus_applet_iface_track_active_changed(NetstatusApplet *applet)
+{
+  gboolean track_active;
+
+  track_active = netstatus_iface_get_track_active_interface (applet->priv->iface);
+  panel_applet_gconf_set_bool(PANEL_APPLET (applet),
+                 "track_active_interface",
+                 track_active,
+                 NULL);
+
+}
+
+static void
 netstatus_applet_iface_name_changed (NetstatusApplet *applet)
 {
   const char *iface_name;
@@ -397,10 +420,29 @@
 {
   if (entry->value && entry->value->type == GCONF_VALUE_STRING)
     {
+      gboolean    track_active;
       const char *iface_name;
 
-      iface_name = gconf_value_get_string (entry->value);
-      netstatus_iface_set_name (applet->priv->iface, iface_name);
+      track_active = netstatus_iface_get_track_active_interface(applet->priv->iface);
+      if ( !track_active ) {
+          iface_name = gconf_value_get_string (entry->value);
+          netstatus_iface_set_name (applet->priv->iface, iface_name);
+      }
+    }
+}
+
+static void
+netstatus_applet_iface_track_active_interface_changed (GConfClient     *client,
+				     guint            cnxn_id,
+				     GConfEntry      *entry,
+				     NetstatusApplet *applet)
+{
+  if (entry->value && entry->value->type == GCONF_VALUE_BOOL)
+    {
+      gboolean track_active;
+
+      track_active = gconf_value_get_bool(entry->value);
+      netstatus_iface_set_track_active_interface (applet->priv->iface, track_active);
     }
 }
 
@@ -408,6 +450,7 @@
 netstatus_applet_create (NetstatusApplet *applet,
 			 const char      *iid)
 {
+  gboolean track_active = FALSE;
   char *iface_name;
   char *key;
 
@@ -424,45 +467,53 @@
   panel_applet_add_preferences (PANEL_APPLET (applet),
 				"/schemas/apps/netstatus_applet/prefs",
 				NULL);
-
-  iface_name = panel_applet_gconf_get_string (PANEL_APPLET (applet),
-					      "interface",
-					      NULL);
-  if (!iface_name || !iface_name [0])
-    {
-      GError *error = NULL;
-      GList  *iface_names;
-
-      g_free (iface_name);
-      iface_name = NULL;
-      
-      iface_names = netstatus_list_interface_names (&error);
-      if (iface_names)
-	{
-	  GList *l;
-
-	  /* FIXME: instead of picking the first one we should
-	   *        figure out what interfaces aren't currently
-	   *        displayed in an applet.
-	   */
-	  iface_name = iface_names->data;
-
-	  for (l = iface_names->next; l; l = l->next)
-	    g_free (l->data);
-	  g_list_free (iface_names);
-	}
-      else
-	{
-	  g_assert (error != NULL);
-	  g_object_set (G_OBJECT (applet->priv->iface),
-			"error", error,
-			NULL);
-	  g_error_free (error);
-	}
-    }
-
-  netstatus_iface_set_name (applet->priv->iface, iface_name);
-  g_free (iface_name);
+  track_active = panel_applet_gconf_get_bool (PANEL_APPLET (applet),
+					      "track_active_interface",
+ 					      NULL);
+  
+  if ( track_active ) {
+      netstatus_iface_set_track_active_interface (applet->priv->iface, track_active );
+  }
+  else {
+          iface_name = panel_applet_gconf_get_string (PANEL_APPLET (applet),
+					              "interface",
+					              NULL);
+          if (!iface_name || !iface_name [0])
+            {
+              GError *error = NULL;
+              GList  *iface_names;
+
+              g_free (iface_name);
+              iface_name = NULL;
+              
+              iface_names = netstatus_list_interface_names (&error);
+              if (iface_names)
+	        {
+	          GList *l;
+
+	          /* FIXME: instead of picking the first one we should
+	           *        figure out what interfaces aren't currently
+	           *        displayed in an applet.
+	           */
+	          iface_name = iface_names->data;
+
+	          for (l = iface_names->next; l; l = l->next)
+	            g_free (l->data);
+	          g_list_free (iface_names);
+	        }
+              else
+	        {
+	          g_assert (error != NULL);
+	          g_object_set (G_OBJECT (applet->priv->iface),
+			        "error", error,
+			        NULL);
+	          g_error_free (error);
+	        }
+            }
+
+          netstatus_iface_set_name (applet->priv->iface, iface_name);
+          g_free (iface_name);
+   }
 
   key = panel_applet_gconf_get_full_key (PANEL_APPLET (applet), "interface");
   applet->priv->notify_id =
@@ -474,6 +525,17 @@
 			     NULL);
   g_free (key);
 
+  key = panel_applet_gconf_get_full_key (PANEL_APPLET (applet), "track_active_interface");
+
+  applet->priv->track_active_interface_id =
+    gconf_client_notify_add (applet->priv->client,
+			     key,
+			     (GConfClientNotifyFunc) netstatus_applet_iface_track_active_interface_changed,
+			     applet,
+			     NULL,
+			     NULL);
+  g_free (key);
+
   return TRUE;
 }
 
--- gnome-netstatus-2.28.0.orig/icons/Makefile.am	2009-09-25 11:46:34.274343975 +0100
+++ gnome-netstatus-2.28.0/icons/Makefile.am	2009-09-25 11:46:40.210390602 +0100
@@ -1,15 +1,4 @@
-icondir = $(datadir)/icons/hicolor/48x48/apps
-icon_DATA = 				\
-	gnome-netstatus-disconn.png	\
-	gnome-netstatus-idle.png	\
-	gnome-netstatus-rx.png		\
-	gnome-netstatus-tx.png		\
-	gnome-netstatus-txrx.png        \
-	gnome-netstatus-error.png       \
-	gnome-netstatus-0-24.png        \
-	gnome-netstatus-25-49.png       \
-	gnome-netstatus-50-74.png       \
-	gnome-netstatus-75-100.png
+SUBDIRS= hicolor
 
 gtk_update_icon_cache = gtk-update-icon-cache -f -t $(datadir)/icons/hicolor
 install-data-hook: update-icon-cache
@@ -23,4 +12,3 @@
 		echo "***   $(gtk_update_icon_cache)"; \
 	fi
 
-EXTRA_DIST = $(icon_DATA)
--- gnome-netstatus-2.28.0.orig/src/netstatus-icon.c	2009-09-25 11:46:34.295164389 +0100
+++ gnome-netstatus-2.28.0/src/netstatus-icon.c	2009-09-25 11:46:40.211557569 +0100
@@ -54,15 +54,21 @@
   GdkPixbuf      *icons [NETSTATUS_STATE_LAST];
   GdkPixbuf      *scaled_icons [NETSTATUS_STATE_LAST];
 
+  GdkPixbuf      *wireless_icons [NETSTATUS_STATE_LAST];
+  GdkPixbuf      *scaled_wireless_icons [NETSTATUS_STATE_LAST];
+
   GdkPixbuf      *signal_icons [NETSTATUS_SIGNAL_LAST];
   GdkPixbuf      *rotated_signal_icons [NETSTATUS_SIGNAL_LAST];
   GdkPixbuf      *scaled_signal_icons [NETSTATUS_SIGNAL_LAST];
 
+  GdkPixbuf     *rendered_wireless_pixbufs[NETSTATUS_STATE_LAST][NETSTATUS_SIGNAL_LAST];
+
   GtkOrientation  orientation;
   int             size;
 
+  gulong          query_tooltip_id;
+
   gulong          state_changed_id;
-  gulong          name_changed_id;
   gulong          wireless_changed_id;
   gulong          signal_changed_id;
 
@@ -119,23 +125,44 @@
 
   for (i = 0; i < NETSTATUS_STATE_LAST; i++)
     {
-      g_object_unref (icon->priv->scaled_icons [i]);
-      icon->priv->scaled_icons [i] = NULL;
+      if ( icon->priv->scaled_icons [i] != NULL ) {
+          g_object_unref (icon->priv->scaled_icons [i]);
+          icon->priv->scaled_icons [i] = NULL;
+      }
 
       g_object_unref (icon->priv->icons [i]);
       icon->priv->icons [i] = NULL;
+
+      g_object_unref (icon->priv->wireless_icons [i]);
+      icon->priv->wireless_icons [i] = NULL;
+
+      if ( icon->priv->scaled_wireless_icons [i] != NULL ) {
+          g_object_unref(icon->priv->scaled_wireless_icons [i]);
+          icon->priv->scaled_wireless_icons [i] = NULL;
+      }
     }
   
   for (i = 0; i < NETSTATUS_SIGNAL_LAST; i++)
     {
-      g_object_unref (icon->priv->scaled_signal_icons [i]);
-      icon->priv->scaled_signal_icons [i] = NULL;
-
-      g_object_unref (icon->priv->signal_icons [i]);
-      icon->priv->signal_icons [i] = NULL;
+      if ( icon->priv->scaled_signal_icons [i] != NULL ) {
+          g_object_unref (icon->priv->scaled_signal_icons [i]);
+          icon->priv->scaled_signal_icons [i] = NULL;
+      }
+
+      if ( icon->priv->signal_icons [i] != NULL ) {
+          g_object_unref (icon->priv->signal_icons [i]);
+          icon->priv->signal_icons [i] = NULL;
+      }
+    }
+
+  for (i = 0; i < NETSTATUS_STATE_LAST; i++) {
+    for (int j = 0; j < NETSTATUS_SIGNAL_LAST; j++) {
+     if ( icon->priv->rendered_wireless_pixbufs[i][j] != NULL ) {
+       g_object_unref(icon->priv->rendered_wireless_pixbufs[i][j]);
+     }
+     icon->priv->rendered_wireless_pixbufs[i][j] = NULL;
     }
-
-  netstatus_icon_init_pixbufs (icon);
+  }
 
   if (icon->priv->size)
     {
@@ -153,6 +180,10 @@
       screen = gtk_widget_get_screen (GTK_WIDGET (icon));
       icon->priv->icon_theme = gtk_icon_theme_get_for_screen (screen);
 
+      gtk_icon_theme_append_search_path (gtk_icon_theme_get_default (),
+                                         NETSTATUS_DATA_DIR G_DIR_SEPARATOR_S "icons");
+
+
       g_signal_connect_object (icon->priv->icon_theme, "changed",
 			       G_CALLBACK (netstatus_icon_theme_changed),
 			       icon,
@@ -286,32 +317,32 @@
 {
   netstatus_icon_init_pixbuf (icon,
 			      &icon->priv->icons [NETSTATUS_STATE_DISCONNECTED],
-			      "gnome-netstatus-disconn");
+			      "network-offline");
   icon->priv->scaled_icons [NETSTATUS_STATE_DISCONNECTED] = NULL;
 
   netstatus_icon_init_pixbuf (icon,
 			      &icon->priv->icons [NETSTATUS_STATE_IDLE],
-			      "gnome-netstatus-idle");
+			      "network-idle");
   icon->priv->scaled_icons [NETSTATUS_STATE_IDLE] = NULL;
 
   netstatus_icon_init_pixbuf (icon,
 			      &icon->priv->icons [NETSTATUS_STATE_TX],
-			      "gnome-netstatus-tx");
+			      "network-transmit");
   icon->priv->scaled_icons [NETSTATUS_STATE_TX] = NULL;
 
   netstatus_icon_init_pixbuf (icon,
 			      &icon->priv->icons [NETSTATUS_STATE_RX],
-			      "gnome-netstatus-rx");
+			      "network-receive");
   icon->priv->scaled_icons [NETSTATUS_STATE_RX] = NULL;
 
   netstatus_icon_init_pixbuf (icon,
 			      &icon->priv->icons [NETSTATUS_STATE_TX_RX],
-			      "gnome-netstatus-txrx");
+			      "network-transmit-receive");
   icon->priv->scaled_icons [NETSTATUS_STATE_TX_RX] = NULL;
 
   netstatus_icon_init_pixbuf (icon,
 			      &icon->priv->icons [NETSTATUS_STATE_ERROR],
-			      "gnome-netstatus-error");
+			      "network-error");
   icon->priv->scaled_icons [NETSTATUS_STATE_ERROR] = NULL;
 
   netstatus_icon_init_pixbuf (icon,
@@ -338,6 +369,38 @@
   icon->priv->rotated_signal_icons [NETSTATUS_SIGNAL_75_100] = NULL;
   icon->priv->scaled_signal_icons  [NETSTATUS_SIGNAL_75_100] = NULL;
 
+  /* Load rx, tx, error, disconnect icons for wireless */
+  netstatus_icon_init_pixbuf (icon,
+			      &icon->priv->wireless_icons [NETSTATUS_STATE_TX],
+			      "gnome-netstatus-wireless-transmit");
+  icon->priv->scaled_wireless_icons [NETSTATUS_STATE_TX] = NULL;
+
+  netstatus_icon_init_pixbuf (icon,
+			      &icon->priv->wireless_icons [NETSTATUS_STATE_RX],
+			      "gnome-netstatus-wireless-receive");
+
+  icon->priv->scaled_wireless_icons [NETSTATUS_STATE_RX] = NULL;
+
+  netstatus_icon_init_pixbuf (icon,
+			      &icon->priv->wireless_icons [NETSTATUS_STATE_TX_RX],
+			      "gnome-netstatus-wireless-transmit-receive");
+  icon->priv->scaled_wireless_icons [NETSTATUS_STATE_TX_RX] = NULL;
+
+  netstatus_icon_init_pixbuf (icon,
+			      &icon->priv->wireless_icons [NETSTATUS_STATE_DISCONNECTED],
+			      "gnome-netstatus-wireless-offline");
+  icon->priv->scaled_wireless_icons [NETSTATUS_STATE_DISCONNECTED] = NULL;
+
+  netstatus_icon_init_pixbuf (icon,
+			      &icon->priv->wireless_icons [NETSTATUS_STATE_IDLE],
+			      "gnome-netstatus-wireless-idle");
+  icon->priv->scaled_wireless_icons [NETSTATUS_STATE_IDLE] = NULL;
+
+  netstatus_icon_init_pixbuf (icon,
+			      &icon->priv->wireless_icons [NETSTATUS_STATE_ERROR],
+			      "gnome-netstatus-wireless-error");
+  icon->priv->scaled_wireless_icons [NETSTATUS_STATE_ERROR] = NULL;
+
   netstatus_icon_rotate_signal_icons (icon, icon->priv->orientation);
 }
 
@@ -356,40 +419,129 @@
   if (gtk_image_get_pixbuf (GTK_IMAGE (icon->priv->image)) != pixbuf)
     gtk_image_set_from_pixbuf (GTK_IMAGE (icon->priv->image), pixbuf);
 
-  pixbuf = icon->priv->scaled_signal_icons [icon->priv->signal_strength];
-  if (!pixbuf)
-    pixbuf = icon->priv->rotated_signal_icons [icon->priv->signal_strength];
-  
-  if (gtk_image_get_pixbuf (GTK_IMAGE (icon->priv->signal_image)) != pixbuf)
-    gtk_image_set_from_pixbuf (GTK_IMAGE (icon->priv->signal_image), pixbuf);
+  if (netstatus_iface_get_is_wireless (icon->priv->iface)) {
+    /* Merge Signal + Status Pixmaps for wireless icon */
+    GdkPixbuf *wireless_state_pixbuf;
+    
+    if ( icon->priv->rendered_wireless_pixbufs[icon->priv->state][icon->priv->signal_strength] == NULL ) {
+      /* Render for first time */
+      GdkPixbuf *rendered_pixbuf; 
+      GdkPixbuf *state_pixbuf; 
+      GdkPixbuf *signal_pixbuf; 
+      gint       back_width;
+      gint       back_height;
+
+      state_pixbuf = icon->priv->scaled_wireless_icons [icon->priv->state];
+      if (!state_pixbuf)
+        state_pixbuf = icon->priv->wireless_icons [icon->priv->state];
+
+      signal_pixbuf = icon->priv->scaled_signal_icons [icon->priv->signal_strength];
+      if (!signal_pixbuf)
+        signal_pixbuf = icon->priv->rotated_signal_icons [icon->priv->signal_strength];
+
+      rendered_pixbuf = gdk_pixbuf_copy(signal_pixbuf);
+      back_width = gdk_pixbuf_get_width (rendered_pixbuf);
+      back_height = gdk_pixbuf_get_height (rendered_pixbuf);
+
+      gdk_pixbuf_composite (state_pixbuf,
+                      rendered_pixbuf,
+                      0, 0,
+                      back_width, back_height,
+                      0, 0,
+                      1.0, 1.0,
+                      GDK_INTERP_NEAREST,
+                      255 );
+
+      icon->priv->rendered_wireless_pixbufs[icon->priv->state][icon->priv->signal_strength] = rendered_pixbuf;
+    }
+
+    /* TODO - Do we handle rotation? 
+    pixbuf = icon->priv->scaled_signal_icons [icon->priv->signal_strength];
+    if (!pixbuf)
+      pixbuf = icon->priv->rotated_signal_icons [icon->priv->signal_strength];
+    */ 
+
+    pixbuf = icon->priv->rendered_wireless_pixbufs[icon->priv->state][icon->priv->signal_strength];
+    if (gtk_image_get_pixbuf (GTK_IMAGE (icon->priv->signal_image)) != pixbuf)
+      gtk_image_set_from_pixbuf (GTK_IMAGE (icon->priv->signal_image), pixbuf);
+  }
 }
 
-static void
-netstatus_icon_name_changed (NetstatusIface *iface,
-			     GParamSpec     *pspec,
-			     NetstatusIcon  *icon)
-{
-  const char *iface_name;
-  const char *tip;
-  char       *freeme = NULL;
-
-  iface_name = netstatus_iface_get_name (icon->priv->iface);
-  if (iface_name)
-    {
-      const char *state_string;
-
-      state_string = netstatus_get_state_string (icon->priv->state);
-      freeme = g_strdup_printf (_("Network Connection: %s\n%s"), iface_name, state_string);
-      tip = freeme;
-    }
-  else
-    {
-      tip = _("Network Connection");
-    }
-
-  gtk_widget_set_tooltip_text (GTK_WIDGET (icon), tip);
+static gboolean
+netstatus_icon_query_tooltip(   NetstatusIcon  *icon,
+                                gint            x,
+                                gint            y,
+                                gboolean        keyboard_mode,
+                                GtkTooltip     *tooltip,
+                                gpointer        user_data)     
+{
+  const char   *iface_name = NULL;
+  char         *ipaddr = NULL;
+  GString      *tooltip_markup = g_string_new("<tt>");
+  char         *cstr;
+
+  if ( !icon->priv->tooltips_enabled )
+      return( FALSE );
+
+  if (icon->priv->iface != NULL ) {
+    if ( netstatus_iface_get_is_wireless (icon->priv->iface)) {
+      const char *iface_essid;
+      const char *iface_bss_mode;
+      gint        signal_strength;
+
+      iface_essid = netstatus_iface_get_essid (icon->priv->iface);
+      iface_bss_mode = netstatus_iface_get_bss_mode (icon->priv->iface);
+      signal_strength = netstatus_iface_get_signal_strength (icon->priv->iface);
+
+      if ( iface_essid != NULL ) {
+        /* SUN_BRANDING */
+        g_string_append_printf(tooltip_markup, _("<b>%-20s</b>: %s"),
+                               /* SUN_BRANDING */
+                               _("Wireless Network"), iface_essid );
+        g_string_append(tooltip_markup, "\n");
+      }
+
+      /* SUN_BRANDING */
+      g_string_append_printf(tooltip_markup, _("<b>%-20s</b>: %d%%"),
+                             /* SUN_BRANDING */
+                             _("Signal Strength"), signal_strength );
+      g_string_append(tooltip_markup, "\n");
+
+      if ( iface_bss_mode != NULL ) {
+        /* SUN_BRANDING */
+        g_string_append_printf(tooltip_markup, _("<b>%-20s</b>: %s"),
+                               /* SUN_BRANDING */
+                               _("Operational Mode"), iface_bss_mode );
+        g_string_append(tooltip_markup, "\n");
+      }
+    }
+
+    iface_name = netstatus_iface_get_name (icon->priv->iface);
+    netstatus_iface_get_inet4_details (icon->priv->iface, &ipaddr, NULL, NULL, NULL );
+
+    if ( ipaddr != NULL ) {
+        /* SUN_BRANDING */
+        g_string_append_printf(tooltip_markup, _("<b>%-20s</b>: %s"),
+                               /* SUN_BRANDING */
+                               _("IP Address (v4)"), ipaddr );
+        g_string_append(tooltip_markup, "\n");
+    }
+
+  }
+  if ( iface_name != NULL ) {
+    g_string_append_printf(tooltip_markup, _("<b>%-20s</b>: %s"), _("Network Connection"), iface_name );
+  }
+  else {
+    g_string_append_printf(tooltip_markup, _("Network Connection")  );
+  }
+
+  g_string_append(tooltip_markup, "</tt>");
+  cstr = g_string_free(tooltip_markup, FALSE);
+  gtk_tooltip_set_markup( tooltip, cstr );
+  g_free(cstr);
 
-  g_free (freeme);
+  g_free(ipaddr);
+  return( TRUE );
 }
 
 static void
@@ -408,7 +560,6 @@
       icon->priv->state = state;
 
       netstatus_icon_update_image (icon);
-      netstatus_icon_name_changed (icon->priv->iface, NULL, icon);
     }
 }
 
@@ -417,10 +568,16 @@
 				    GParamSpec     *pspec,
 				    NetstatusIcon  *icon)
 {
-  if (netstatus_iface_get_is_wireless (iface) && icon->priv->show_signal)
+  netstatus_icon_update_image (icon);
+
+  if (netstatus_iface_get_is_wireless (iface) && icon->priv->show_signal) {
+    gtk_widget_hide (icon->priv->image);
     gtk_widget_show (icon->priv->signal_image);
-  else
+  }
+  else {
+    gtk_widget_show (icon->priv->image);
     gtk_widget_hide (icon->priv->signal_image);
+  }
 }
 
 static void
@@ -459,21 +616,23 @@
     gtk_widget_destroy (icon->priv->error_dialog);
   icon->priv->error_dialog = NULL;
 
+  if ( icon->priv->query_tooltip_id ) {
+      g_signal_handler_disconnect (icon,
+				   icon->priv->query_tooltip_id);
+  }
+  icon->priv->query_tooltip_id    = 0;
+
   if (icon->priv->state_changed_id)
     {
       g_assert (icon->priv->iface != NULL);
-      g_assert (icon->priv->name_changed_id != 0);
       g_signal_handler_disconnect (icon->priv->iface,
 				   icon->priv->state_changed_id);
       g_signal_handler_disconnect (icon->priv->iface,
-				   icon->priv->name_changed_id);
-      g_signal_handler_disconnect (icon->priv->iface,
 				   icon->priv->wireless_changed_id);
       g_signal_handler_disconnect (icon->priv->iface,
 				   icon->priv->signal_changed_id);
     }
   icon->priv->state_changed_id    = 0;
-  icon->priv->name_changed_id     = 0;
   icon->priv->wireless_changed_id = 0;
   icon->priv->signal_changed_id   = 0;
 
@@ -566,6 +725,16 @@
 						   TRUE);
     }
 
+  for (i = 0; i < NETSTATUS_STATE_LAST; i++)
+    {
+      if (icon->priv->scaled_wireless_icons [i])
+	g_object_unref (icon->priv->scaled_wireless_icons [i]);
+      icon->priv->scaled_wireless_icons [i] = scale_pixbuf (icon->priv->wireless_icons [i],
+						   icon->priv->orientation,
+						   size,
+						   TRUE);
+    }
+
   for (i = 0; i < NETSTATUS_SIGNAL_LAST; i++)
     {
       if (icon->priv->scaled_signal_icons [i])
@@ -573,8 +742,18 @@
       icon->priv->scaled_signal_icons [i] = scale_pixbuf (icon->priv->rotated_signal_icons [i],
 							  icon->priv->orientation,
 							  size,
-							  FALSE);
+							  TRUE);
     }
+ 
+   /* Invalidate rendered icons */
+  for (i = 0; i < NETSTATUS_STATE_LAST; i++) {
+    for (int j = 0; j < NETSTATUS_SIGNAL_LAST; j++) {
+     if ( icon->priv->rendered_wireless_pixbufs[i][j] != NULL ) {
+       g_object_unref(icon->priv->rendered_wireless_pixbufs[i][j]);
+     }
+     icon->priv->rendered_wireless_pixbufs[i][j] = NULL;
+    }
+  }
 
   netstatus_icon_update_image (icon);
 }
@@ -862,12 +1041,15 @@
 
   icon->priv->image = gtk_image_new ();
   gtk_container_add (GTK_CONTAINER (icon), icon->priv->image);
-  gtk_widget_show (icon->priv->image);
+  gtk_widget_hide (icon->priv->image);
 
   icon->priv->signal_image = gtk_image_new ();
   gtk_container_add (GTK_CONTAINER (icon), icon->priv->signal_image);
   gtk_widget_hide (icon->priv->signal_image);
 
+  icon->priv->query_tooltip_id  = g_signal_connect(icon, "query-tooltip",
+                                                   G_CALLBACK (netstatus_icon_query_tooltip), NULL);
+  
   gtk_widget_add_events (GTK_WIDGET (icon),
 			 GDK_BUTTON_PRESS_MASK | GDK_ENTER_NOTIFY_MASK | GDK_LEAVE_NOTIFY_MASK);
 }
@@ -971,12 +1153,9 @@
       if (icon->priv->state_changed_id)
 	{
 	  g_assert (icon->priv->iface != NULL);
-	  g_assert (icon->priv->name_changed_id != 0);
 	  g_signal_handler_disconnect (icon->priv->iface,
 				       icon->priv->state_changed_id);
 	  g_signal_handler_disconnect (icon->priv->iface,
-				       icon->priv->name_changed_id);
-	  g_signal_handler_disconnect (icon->priv->iface,
 				       icon->priv->wireless_changed_id);
 	  g_signal_handler_disconnect (icon->priv->iface,
 				       icon->priv->signal_changed_id);
@@ -991,15 +1170,12 @@
 
       icon->priv->state_changed_id     = g_signal_connect (icon->priv->iface, "notify::state",
 							   G_CALLBACK (netstatus_icon_state_changed), icon);
-      icon->priv->name_changed_id      = g_signal_connect (icon->priv->iface, "notify::name",
-							   G_CALLBACK (netstatus_icon_name_changed), icon);
       icon->priv->wireless_changed_id  = g_signal_connect (icon->priv->iface, "notify::wireless",
 							   G_CALLBACK (netstatus_icon_is_wireless_changed), icon);
       icon->priv->signal_changed_id    = g_signal_connect (icon->priv->iface, "notify::signal-strength",
 							   G_CALLBACK (netstatus_icon_signal_changed), icon);
 
       netstatus_icon_state_changed       (icon->priv->iface, NULL, icon);
-      netstatus_icon_name_changed        (icon->priv->iface, NULL, icon);
       netstatus_icon_is_wireless_changed (icon->priv->iface, NULL, icon);
       netstatus_icon_signal_changed      (icon->priv->iface, NULL, icon);
 
--- gnome-netstatus-2.28.0.orig/src/netstatus-sysdeps.h	2009-09-25 11:46:34.295394995 +0100
+++ gnome-netstatus-2.28.0/src/netstatus-sysdeps.h	2009-09-25 11:46:40.212586971 +0100
@@ -34,9 +34,36 @@
 						     gulong     *out_packets,
 						     gulong     *in_bytes,
 						     gulong     *out_bytes);
+#if defined (__sun)
+
+typedef struct {
+    char       *essid;
+    gboolean    connected;       
+    char       *bssid;
+    char       *bss_mode;
+    int         signal_strength;
+    char       *mode;
+    char       *security;
+    char       *auth_mode;
+} wifi_info_t;
+
+wifi_info_t* netstatus_wifi_info_new(   char       *essid,
+                                        gboolean    connected,
+                                        char       *bssid,
+                                        char       *bss_mode,
+                                        int         signal_strength,
+                                        char       *mode,
+                                        char       *security,
+                                        char       *auth_mode );
+
+void netstatus_wifi_info_free( wifi_info_t * wi );
+
+wifi_info_t *netstatus_sysdeps_read_iface_wireless_details (const char *iface);
+#else
 char *netstatus_sysdeps_read_iface_wireless_details (const char *iface,
 						     gboolean   *is_wireless,
 						     int        *signal_strength);
+#endif
 
 G_END_DECLS
 
